

#property indicator_chart_window

extern bool Show_Simple_Text = true;
extern bool Show_Standard_Comments = FALSE;
extern bool Show_Colored_TEXT = TRUE;
extern int Text_Size = 8;

extern int Shift_Text_UP_DN = 80;
extern int Shift_Text_Left_Right = 0;
extern color Title_Color = SteelBlue;
extern color Prev_4Hr_Text = DarkKhaki;
extern color Next_Text = Coral;
extern color Broker_Time = Peru;
extern color CountDown_Time = Gold;

int init() {
   return (0);
}

int deinit() {
   ObjectDelete("FHour");
   ObjectDelete("FHour1");
   ObjectDelete("FHour2");
   ObjectDelete("FHour3");
   ObjectDelete("FHour4");
   return (0);
}

int start() {
   double l_iclose_0 = iClose(NULL, PERIOD_H4, 1);
   double l_datetime_8 = iTime(NULL, PERIOD_H4, 0);
   double ld_16 = iTime(NULL, PERIOD_H4, 0) + 14400;
   double l_datetime_24 = TimeCurrent();
   double l_ima_32 = iMA(Symbol(), 0, 1, 0, MODE_EMA, PRICE_CLOSE, 0);
   double ld_40 = iTime(NULL, PERIOD_H4, 5) + 864000 - TimeCurrent();
   int li_unused_48 = IndicatorCounted();
   if (Show_Standard_Comments == TRUE) {
      if (Show_Simple_Text == FALSE) {
         Comment("" 
            + "\n" 
            + "4 Hour Candle Close Data" 
            + "\n" 
            + "Close Prev 4Hour  " + TimeToStr(l_datetime_8) + "   @   " + DoubleToStr(l_iclose_0, Digits) 
            + "\n" 
            + "Time of NEXT 4Hour Close  " + TimeToStr(ld_16) 
            + "\n" 
            + "Broker Time  " + TimeToStr(l_datetime_24) + "   @   " + DoubleToStr(l_ima_32, Digits) 
            + "\n" 
         + "4 Hour CountDown  " + TimeToStr(ld_40, Digits));
      }
   }
   if (Show_Standard_Comments == TRUE) {
      if (Show_Simple_Text == TRUE) {
         Comment("" 
            + "\n" 
         + "4 Hour CountDown  " + TimeToStr(ld_40, Digits));
      }
   }
   if (Show_Colored_TEXT == TRUE) {
      if (Show_Simple_Text == FALSE) {
         ObjectCreate("FHour", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("FHour", "4 Hour Candle Close Data", Text_Size, "Arial Black", Title_Color);
         ObjectSet("FHour", OBJPROP_CORNER, 0);
         ObjectSet("FHour", OBJPROP_XDISTANCE, Shift_Text_Left_Right + 5);
         ObjectSet("FHour", OBJPROP_YDISTANCE, (Shift_Text_UP_DN + 15) * Text_Size / 10);
         ObjectCreate("FHour1", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("FHour1", "Close Prev 4 Hour :   " + TimeToStr(l_datetime_8) + "   @   " + DoubleToStr(l_iclose_0, Digits), Text_Size, "Arial Black", Prev_4Hr_Text);
         ObjectSet("FHour1", OBJPROP_CORNER, 0);
         ObjectSet("FHour1", OBJPROP_XDISTANCE, Shift_Text_Left_Right + 5);
         ObjectSet("FHour1", OBJPROP_YDISTANCE, (Shift_Text_UP_DN + 30) * Text_Size / 10);
         ObjectCreate("FHour2", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("FHour2", "Time of NEXT 4 Hour Close :   " + TimeToStr(ld_16), Text_Size, "Arial Black", Next_Text);
         ObjectSet("FHour2", OBJPROP_CORNER, 0);
         ObjectSet("FHour2", OBJPROP_XDISTANCE, Shift_Text_Left_Right + 5);
         ObjectSet("FHour2", OBJPROP_YDISTANCE, (Shift_Text_UP_DN + 45) * Text_Size / 10);
         ObjectCreate("FHour3", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("FHour3", "Broker Time :   " + TimeToStr(l_datetime_24) + "   @   " + DoubleToStr(l_ima_32, Digits), Text_Size, "Arial Black", Broker_Time);
         ObjectSet("FHour3", OBJPROP_CORNER, 0);
         ObjectSet("FHour3", OBJPROP_XDISTANCE, Shift_Text_Left_Right + 5);
         ObjectSet("FHour3", OBJPROP_YDISTANCE, (Shift_Text_UP_DN + 60) * Text_Size / 10);
         ObjectCreate("FHour4", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("FHour4", "4 Hour CountDown :   " + TimeToStr(ld_40, Digits) + "", Text_Size, "Arial Black", CountDown_Time);
         ObjectSet("FHour4", OBJPROP_CORNER, 0);
         ObjectSet("FHour4", OBJPROP_XDISTANCE, Shift_Text_Left_Right + 5);
         ObjectSet("FHour4", OBJPROP_YDISTANCE, (Shift_Text_UP_DN + 75) * Text_Size / 10);
      }
   }
   if (Show_Simple_Text == TRUE) {
      if (Show_Colored_TEXT == TRUE) {
         ObjectCreate("FHour4", OBJ_LABEL, 0, 0, 0);
         ObjectSetText("FHour4", "4 Hour CountDown :   " + TimeToStr(ld_40, Digits) + "", Text_Size, "Arial Black", CountDown_Time);
         ObjectSet("FHour4", OBJPROP_CORNER, 0);
         ObjectSet("FHour4", OBJPROP_XDISTANCE, Shift_Text_Left_Right + 5);
         ObjectSet("FHour4", OBJPROP_YDISTANCE, (Shift_Text_UP_DN + 15) * Text_Size / 10);
      }
   }
   RefreshRates();
   return (0);
}